mutable struct Equation{T_EoS<:AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
  atm_density::Float64
  atm_factor::Float64
  atm_threshold::Float64
end


struct Project{Formulation,
               T_Eq    <:AbstractEquation,
               T_HRSC  <:Maybe{HRSC.AbstractHRSC},
               T_TCI   <:Maybe{TCI.AbstractTCI},
               T_Prms}
  equation::T_Eq
  hrsc::T_HRSC
  tci::T_TCI
  prms::T_Prms
end
Project(formulation, fields...) = Project{formulation,typeof.(fields)...}(fields...)


formulation(::Project{F}) where F = F
