struct FVElement
  N::Int64                # polynomial order
  Npts::Int64             # number of quadrature points = N + 1
  z::Vector{Float64}      # quadrature points

  function FVElement()
    N = 0
    Npts = N + 1
    z = [0.0]
    return new(N, Npts, z)
  end
end


@inline function inner_product(u1, u2, el::FVElement)
  TODO()
  @unpack quadr = el
  @toggled_assert quadr in (:LGL, :LGL_lumped, :GLGL)
  if quadr === :LGL || quadr === :LGL_lumped
    return LGL.integrate(el.w, u1, u2)
  else # quadr === :GLGL
    return GLGL.integrate(el.w, el.v, el.D, u1, u2)
  end
end


@inline function integrate(u, el::FVElement)
  TODO()
  @unpack quadr = el
  @toggled_assert quadr in (:LGL, :LGL_lumped, :GLGL)
  if quadr === :LGL || quadr === :LGL_lumped
    return LGL.integrate(el.w, u)
  else # quadr === :GLGL
    return GLGL.integrate(el.w, el.v, el.D, u)
  end
end
